package EntradaSalida;

#


$SI=1;
$NO=0;

sub Nueva
{
	my $this=shift;
	my $clase=ref($this) || $this;
	my ($nombre_fichero)=@_;
	my $es={};

	$es->{Abierta}=$NO;
	if(defined $nombre_fichero)
	{
		$fichero=$nombre_fichero;
		if(defined(open $fichero , $nombre_fichero))
		{
			$es->{Fichero}=$fichero;
			$ficheros_abiertos++;
			$es->{Abierta}=$SI;
		}
	}
	else
	{
		$es->{Fichero}=\*STDOUT;
		$es->{Abierta}=$SI;
	}
	$es->{Tabulacion}=0;
	$es->{CadenaTabulacion}="\t";
	$es->{RepeticionCadenaTabulacion}=1;

	$es->{UltimoCaracter}="\n";

	bless $es, $clase;
	return $es;
}

sub Abrir
{
	my $es=shift;
	my ($nombre_fichero)=@_;

	$es->Cerrar;
	if(defined $nombre_fichero)
	{
		if(defined(open $nombre_fichero , $nombre_fichero))
		{
			$es->{Fichero}=$nombre_fichero;
			$ficheros_abiertos++;
			$es->{Abierta}=$SI;
		}
	}
	else
	{
		$es->{Fichero}=\*STDOUT;
		$es->{Abierta}=$SI;
	}
}

sub Leer
{
	my $es=shift;

	if($es->{Abierta}==$SI)
	{
		if(!eof($es->{Fichero}))
		{
			my $caracter;
			my $linea='';
			my $fin_linea=$NO;
			do
			{
				read $es->{Fichero}, $caracter, 1;
				if($caracter=~/[\r\n]/)
				{
					$fin_linea=$SI;
				}
				else
				{
					$linea="$linea$caracter";
				}
				$caracter='';
			}
			while((!eof($es->{Fichero}))&&($fin_linea==$NO));
			$_=$linea;
			return $linea;
		}
	}

	return undef;
}


sub Escribir
{
	my $es=shift;
	my ($cadena)=@_;

	if($es->{Abierta}==$SI)
	{
		print {$es->{Fichero}} $es->{CadenaTabulacion} x ($es->{Tabulacion}*$es->{RepeticionCadenaTabulacion}) if ($es->{UltimoCaracter} eq "\n");
		print {$es->{Fichero}} $cadena;
	}
	$es->{UltimoCaracter}=chop($cadena);
}

sub Tabular
{
	my $es=shift;
	my ($n)=@_;

	if(defined $n)
	{
		$es->{Tabulacion}+=$n;
	}
	else
	{
		$es->{Tabulacion}++;
	}
}

sub Destabular
{
	my $es=shift;
	my ($n)=@_;

	if(defined $n)
	{
		$es->{Tabulacion}-=$n;
	}
	else
	{
		$es->{Tabulacion}--;
	}
	if($es->{Tabulacion}<0)
	{
		$es->{Tabulacion}=0;
	}
}

sub Cerrar
{
	my $es=shift;

	if($es->{Abierta}==$SI)
	{
		close $es->{Fichero};
	}
}

1;

