package Sequence;

require Exporter;

require DBI;
require Diario;
require GestorDatos;

@ISA=qw(Exporter);

@EXPORT = qw(Nueva Incrementar Consultar PonerValor Resincronizar EliminarSuperiores);

$INDEFINIDO=-1;

# ----------------------------------------------------------------------------------------------------
# ****************************************************************************************************
# ----------------------------------------------------------------------------------------------------

sub Nueva
{
	my $this=shift;
	my $clase=ref($this) || $this;
	my $sequence={};
	my ($nombre,$tabla,$identificador,$valor)=@_;

	$sequence->{Nombre}=$nombre;
	$sequence->{Tabla}=$tabla;
	$sequence->{Identificador}=$identificador;
	if(defined $valor)
	{
		$sequence->{Valor}=$valor;
	}
	else
	{
		$sequence->{Valor}=0;
	}
	$sequence->{UtilizarSequenceBaseDeDatos}=$NO;

	bless $sequence,$clase;
	return $sequence;
}

sub Incrementar
{
	my $sequence=shift;

	my $anterior=$sequence->{Valor};
	if($sequence->{Valor}!=$INDEFINIDO)
	{
		$sequence->{Valor}++;
	}

	return $anterior;
}

sub Consultar
{
	my $sequence=shift;

	return $sequence->{Valor};
}

sub PonerValor
{
	my $sequence=shift;
	my ($valor)=@_;

	$sequence->{Valor}=$valor;
}

sub Resincronizar
{
	my $sequence=shift;
	my ($gestor_datos,$diario)=@_;

	my $id=0;
	$diario->Apuntar("Resincronizando la secuencia $sequence->{Nombre}... ");
	if($sequence->{UtilizarSequenceBaseDeDatos})
	{
		$gestor_datos->EjecutarSentencia(\$id,"DROP SEQUENCE BIBLIOMETRIC.$sequence->{Nombre}");
		$gestor_datos->FinalizarSentencia($id);
	}
	my @max_id=$gestor_datos->Consultar("SELECT MAX($sequence->{Identificador}) FROM BIBLIOMETRIC.$sequence->{Tabla}");
	$sequence->{Valor}=$max_id[0]+1;
	$diario->Apuntar("con valor inicial $sequence->{Valor}... ");
	if($sequence->{UtilizarSequenceBaseDeDatos})
	{
		$gestor_datos->EjecutarSentencia(\$id,"CREATE SEQUENCE BIBLIOMETRIC.$sequence->{Nombre} START WITH $sequence->{Valor}");
		$gestor_datos->FinalizarSentencia($id);
	}
	$diario->Apuntar("OK\n");

	return $sequence->{Valor};
}

sub EliminarSuperiores
{
	my $sequence=shift;
	my ($gestor_datos,$diario)=@_;

	my $id=0;
	my @ini=$gestor_datos->Consultar("SELECT COUNT(*) FROM BIBLIOMETRIC.$sequence->{Tabla} WHERE $sequence->{Identificador} >= $sequence->{Valor}");
	$diario->Apuntar("Eliminar $ini[0] registros de la tabla $sequence->{Tabla} donde el campo $sequence->{Identificador} es superior a $sequence->{Valor} segun la secuencia $sequence->{Nombre} (Return = continuar)");
	getc();
	my $ok=$gestor_datos->EjecutarSentencia(\$id,"DELETE FROM BIBLIOMETRIC.$sequence->{Tabla} WHERE $sequence->{Identificador} >= $sequence->{Valor}");
	$gestor_datos->FinalizarSentencia($id);
	my @fin=$gestor_datos->Consultar("SELECT COUNT(*) FROM BIBLIOMETRIC.$sequence->{Tabla} WHERE $sequence->{Identificador} >= $sequence->{Valor}");

	if($ok)
	{
		$borradas=$ini[0]-$fin[0];
		$diario->Apuntar("$borradas registros eliminados.\n");
	}
	return $ok;
}

1;
