package Sequences;

require Exporter;

require DBI;
require Diario;
require GestorDatos;
require Sequence;

@ISA=qw(Exporter);

@EXPORT = qw(Nuevas Anadir Resincronizar EliminarSuperiores Listar);

# ----------------------------------------------------------------------------------------------------
# ****************************************************************************************************
# ----------------------------------------------------------------------------------------------------

sub Nuevas
{
	my $this=shift;
	my $clase=ref($this) || $this;
	my $sequences={};
	my ($gestor_datos,$diario)=@_;

	$sequences->{NumSequences}=0;
	$sequences->{Sequences}={};
	$sequences->{GestorDatos}=$gestor_datos;
	$sequences->{Diario}=$diario;
	$sequences->{UtilizarSequencesBaseDeDatos}=$NO;

	bless $sequences,$clase;
	return $sequences;
	
}

sub Anadir
{
	my $sequences=shift;
	my ($nombre,$tabla,$identificador,$valor)=@_;

	if(!(exists $sequences->{Sequences}->{$nombre}))
	{
		$sequences->{Sequences}->{$nombre}=Nueva Sequence($nombre,$tabla,$identificador,$valor);
		$sequences->{Sequences}->{$nombre}->{UtilizarSequenceBaseDeDatos}=$sequences->{UtilizarSequencesBaseDeDatos};
		$sequences->{NumSequences}++;
	}

	return $sequences->{Sequences}->{$nombre};
}

sub Resincronizar
{
	my $sequences=shift;

	my @valores=();
	my $id=0;
	foreach my $nombre (keys %{$sequences->{Sequences}}) 
	{
		shift @valores, $sequences->{Sequences}->{$nombre}->Resincronizar($sequences->{GestorDatos},$sequences->{Diario});
	}

	return @valores;
}

sub EliminarSuperiores
{
	my $sequences=shift;
	
	my ($nombre)=@_;

	if(defined $nombre)
	{
		$sequences->{Sequences}->{$nombre}->EliminarSuperiores($sequences->{GestorDatos},$sequences->{Diario});
	}
	else
	{
		foreach my $seq_name (keys %{$sequences->{Sequences}}) 
		{
			$sequences->{Sequences}->{$seq_name}->EliminarSuperiores($sequences->{GestorDatos},$sequences->{Diario});
		}
	}
}

sub Listar
{
	my $sequences=shift;

	foreach my $seq_name (keys %{$sequences->{Sequences}}) 
	{
		$sequences->{Diario}->Apuntar("BIBLIOMETRIC.$seq_name = $sequences->{Sequences}->{$seq_name}->{Valor}\n");
	}
}

1;
