package Cronometro;

#


require Util;
require Diario;

use Global;

# Estados de un cronmetro:
$PARADO=0;
$CORRIENDO=1;

sub Nuevo
{
	my $this=shift;
	my $clase=ref($this) || $this;
	my $crono={};

	$crono->{Inicio}=0;
	$crono->{Fin}=0;
	$crono->{Contador}=0;
	$crono->{Estado}=$PARADO;

	bless $crono,$clase;
	return $crono;
}

sub Inicializar
{
	my $crono=shift;

	$crono->{Inicio}=0;
	$crono->{Fin}=0;
	$crono->{Contador}=0;
	$crono->{Estado}=$PARADO;
}

sub Iniciar
{
	my $crono=shift;

	$crono->{Inicio}=time;
	$crono->{Estado}=$CORRIENDO;
}

sub Parar
{
	my $crono=shift;

	if($crono->{Estado}==$CORRIENDO)
	{
		$crono->{Fin}=time;
		$crono->{Contador}+=($crono->{Fin}-$crono->{Inicio});
		$crono->{Estado}=$PARADO;
	}
}

sub Mostrar
{
	my $crono=shift;

	if($crono->{Estado}==$PARADO)
	{
		my $horas=Util::Truncar($crono->{Contador}/3600);
		my $minutos=Util::Truncar(($crono->{Contador}%3600)/60);
		my $segundos=$crono->{Contador}%60;
		my $cadena=sprintf("Duracin: %u:%02u:%02u\n",$horas,$minutos,$segundos);
		$diario->Apuntar($cadena);
	}
}

1;