package Cola;

# Implementa una cola de prioridad mediante una estructura heap para elementos 
# {clave,valor} ordenando por valor.

require Util;

$CLAVE=0;
$VALOR=1;

sub Nueva
{
	my $this=shift;
	my $clase=ref($this) || $this;
	my $cola={};

	$cola->{Heap}=[];
	$cola->{Heap}[0]=(0,0);
	$cola->{NumElementos}=0;

	bless $cola,$clase;
	return $cola;
}

sub Cola::Padre
{
	my ($i)=@_;
	return Util::Truncar($i/2);
}

sub Cola::HijoDerecho
{
	my ($i)=@_;
	return $i*2+1;
}

sub Cola::HijoIzquierdo
{
	my ($i)=@_;
	return $i*2;
}

sub SubirElemento
{
	my $cola=shift;
	my ($desde,$clave,$valor)=@_;

	$i=$desde;
	while(($i>1)&&($cola->{Heap}[Cola::Padre($i)][$VALOR]>$valor))
	{
		$cola->{Heap}[$i]=$cola->{Heap}[Cola::Padre($i)];
		$cola->{Posicion}[$cola->{Heap}[$i][$CLAVE]]=$i;
		$i=Cola::Padre($i);
	}
	$cola->{Heap}[$i]=($clave,$valor);
	$cola->{Posicion}[$clave]=$i;
}

sub BajarElemento
{
	my $cola=shift;
	my ($desde,$clave,$valor)=@_;

	my ($i,$d,$min);
	
	$i=Cola::HijoIzquierdo($desde);
	$d=Cola::HijoDerecho($desde);
	if(($i<=$cola->{NumElementos})&&($cola->{Heap}[$i][$VALOR]<$valor))
	{
		$min=$i;
	}
	else
	{
		$min=$d;
	}
	if(($d<=$cola->{NumElementos})&&($cola->{Heap}[$d][$VALOR]<$cola->{Heap}[$min][$VALOR]))
	{
		$min=$i;
	}
	if($min!=$desde)
	{
		$cola->{Heap}[$desde]=$cola->{Heap}[$min];
		$cola->{Heap}[$min]=($clave,$valor);
		$cola->BajarElemento($min,$clavem,$valor);
	}
}

sub Modificar
{
	my $cola=shift;
	my ($clave,$valor)=@_;

	my ($i);

	if(defined $cola->{Posicion}[$clave])
	{
		$posicion=$cola->{Posicion}[$clave];
		$valor_actual=$cola->{Heap}[$posicion][$VALOR];
		if($valor<$valor_actual)
		{
			$cola->SubirElemento($posicion,$clave,$valor);
		}
		else
		{
			$cola->BajarElemento($posicion,$clave,$valor);
		}
	}
}

sub Insertar
{
	my $cola=shift;
	my ($clave,$valor)=@_;

	if(defined $cola->{Posicion}[$clave])
	{
		$cola->Modificar($clave,$valor);
	}
	else
	{
		$cola->SubirElemento(++$cola->{NumElementos},$calve,$valor);
	}
}

sub ExtraerMinimo
{
	my $cola=shift;

	my (@min);

	if($cola->{NumElementos}>0)
	{
		@min=$cola->{Heap}[1];
		$cola->{Heap}[1]=$cola->{Heap}[$cola->{NumElementos}];
		$cola->BajarElemento(1,$cola->{Heap}[$cola->{NumElementos}][$CLAVE],$cola->{Heap}[$cola->{NumElementos}][$VALOR]);
		$cola->{NumElementos}--;
		return @min;
	}
}

sub Mostrar
{
	my $cola=shift;

	for($i=1;$i<=$cola->{NumElementos};$i++)
	{
		print "CLAVE: $cola->{Heap}[$i][$CLAVE], VALOR: $cola->{Heap}[$i][$CLAVE], POS: $cola->{Posicion}[$cola->{Heap}[$i][$CLAVE]]\n";
	}
}

1;
