package Sets;

#

require Util;

$INDEFINIDO=-1;

$PARENT=0;
$RANK=1;

sub new
{
	my $this=shift;
	my $clase=ref($this) || $this;
	my $sets={};

	$sets->{Parent}=[];
	$sets->{Rank}=[];
	$sets->{NumSets}=0;
	$sets->{NumElements}=0;

	bless $sets,$clase;
	return $sets;
}

sub MakeSet
{
	my $sets=shift;
	my ($element)=@_;

	$sets->{Parent}[$element]=$element;
	$sets->{Rank}[$element]=0;
	$sets->{NumSets}++;
	$sets->{NumElements}++;
}

sub FindSet
{
	my $sets=shift;
	my ($element)=@_;

	if($element!=$sets->{Parent}[$element])
	{
		$sets->{Parent}[$element]=$sets->FindSet($sets->{Parent}[$element]);
	}
	return $sets->{Parent}[$element];
}

sub Link
{
	my $sets=shift;
	my ($element1,$element2)=@_;

	if($element1!=$element2)
	{
		if($sets->{Rank}[$element1]>$sets->{Rank}[$element2])
		{
			$sets->{Parent}[$element2]=$element1;
		}
		else
		{
			$sets->{Parent}[$element1]=$element2;
			if($sets->{Rank}[$element1]==$sets->{Rank}[$element2])
			{
				$sets->{Rank}[$element2]=$sets->{Rank}[$element2]+1;
			}
		}
		$sets->{NumSets}--;
	}
}

sub Union
{
	my $sets=shift;
	my ($element1,$element2)=@_;

	$sets->Link($sets->FindSet($element1),$sets->FindSet($element2));
}


sub ListarRepresentantes
{
	my $sets=shift;
	my ($representantes)=@_;

	$i=0;
	for($elemento=0;$elemento<$sets->{NumElements};$elemento++)
	{
		if($sets->{Parent}[$elemento]==$elemento)
		{
			$$representantes{$elemento}=$i;
			$i++;
		}
	}
}